// This sample shows how to easily implement 'tool-tips' in FiveWin!

#include "FiveWin.ch"

static oWnd

//----------------------------------------------------------------------------//

function Main()

   local oBar

   DEFINE WINDOW oWnd TITLE "ToolTips in FiveWin!"

   DEFINE BUTTONBAR oBar 3D SIZE 33, 33 OF oWnd

   DEFINE BUTTON OF oBar ACTION MsgInfo( "One" )
   DEFINE BUTTON OF oBar ACTION MsgInfo( "Two" )
   DEFINE BUTTON OF oBar ACTION MsgInfo( "Three" )
   DEFINE BUTTON OF oBar ACTION MsgInfo( "Four" )

   SET MESSAGE OF oWnd ;
     TO "FiveWin: CA-Clipper, xBase && OOPS development power" CENTER

   ACTIVATE WINDOW oWnd ;
      ON INIT SetToolTip()

return nil

//----------------------------------------------------------------------------//

function SetToolTip()

   local oTmr

   DEFINE TIMER oTmr INTERVAL 250 OF oWnd ;    // 1000 => 1 second
      ACTION CheckToolTip()

   ACTIVATE TIMER oTmr

return nil

//----------------------------------------------------------------------------//

function CheckToolTip()

   local aMousePos := GetCursorPos()
   local oBrush

   static oDlg
   static nMRow    := 0, nMCol := 0
   static nTicks   := 0

   if aMousePos[ 1 ] == nMRow .and. aMousePos[ 2 ] == nMCol
      if ++nTicks == 5 // 1,25 second !

         DEFINE BRUSH oBrush COLOR RGB( 255, 255, 150 )

         DEFINE DIALOG oDlg FROM 0, 0 TO 10, 80 PIXEL ;
            STYLE nOr( WS_POPUP, DS_SYSMODAL ) ;
            BRUSH oBrush

         oDlg:bMMoved = { || oDlg:End() }

         ACTIVATE DIALOG oDlg ;
            ON INIT  oDlg:Move( aMousePos[ 1 ] + 20, aMousePos[ 2 ] - 10 ) ;
            ON PAINT WndBox( oDlg:hDC, 0, 0, 11, 81 )

         nTicks = 0
         oDlg   = nil

      endif
   else
      if oDlg != nil
         oDlg:End()
      endif
   endif

   nMRow = aMousePos[ 1 ]
   nMCol = aMousePos[ 2 ]

return nil

//----------------------------------------------------------------------------//
